# Change Log

## [Unreleased](https://github.com/feelpp/feelpp/tree/HEAD)

[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.100.0...HEAD)

**Closed issues:**

- Upgrade Eigen3 to 3.3  [\#736](https://github.com/feelpp/feelpp/issues/736)
- Support boost \>= 1.60 [\#729](https://github.com/feelpp/feelpp/issues/729)
- Issue bluiding fluid exemple [\#728](https://github.com/feelpp/feelpp/issues/728)
- CRB apps: Issues with building [\#727](https://github.com/feelpp/feelpp/issues/727)
- Fix normLinf and minmax when some process has no mesh elements [\#718](https://github.com/feelpp/feelpp/issues/718)
- Support for io streams in parallel [\#715](https://github.com/feelpp/feelpp/issues/715)
- Support expressions in material properties  [\#710](https://github.com/feelpp/feelpp/issues/710)
- Support casting down to backend specific version of backends, matrices, vectors, preconditioners [\#709](https://github.com/feelpp/feelpp/issues/709)
- Provide access to preconditioner from the Backend [\#708](https://github.com/feelpp/feelpp/issues/708)
- Support functions definition in json file for SolidMechanics model [\#707](https://github.com/feelpp/feelpp/issues/707)
- Support reading Acusim Raw Mesh formats [\#706](https://github.com/feelpp/feelpp/issues/706)
- Support partitioning strategies  [\#579](https://github.com/feelpp/feelpp/issues/579)
- Add tests for a list of range [\#470](https://github.com/feelpp/feelpp/issues/470)

**Merged pull requests:**

- Feature/materials [\#742](https://github.com/feelpp/feelpp/pull/742) ([romainhild](https://github.com/romainhild))
- Feature/eigen3 [\#737](https://github.com/feelpp/feelpp/pull/737) ([prudhomm](https://github.com/prudhomm))
- Feature/cnab2 [\#725](https://github.com/feelpp/feelpp/pull/725) ([jbwahl](https://github.com/jbwahl))
- Feature/hdf5 mesh partitioner [\#705](https://github.com/feelpp/feelpp/pull/705) ([vincentchabannes](https://github.com/vincentchabannes))
- Feature/hdf5 mesh partitioner [\#698](https://github.com/feelpp/feelpp/pull/698) ([prudhomm](https://github.com/prudhomm))
- feature/crb cobuild [\#598](https://github.com/feelpp/feelpp/pull/598) ([cdaversin](https://github.com/cdaversin))

## [v0.100.0](https://github.com/feelpp/feelpp/tree/v0.100.0) (2016-01-25)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.100.0-beta.7...v0.100.0)

**Closed issues:**

- degree of polynomial [\#703](https://github.com/feelpp/feelpp/issues/703)
- feel\_test\_integration FTBS [\#693](https://github.com/feelpp/feelpp/issues/693)
- cmake broken for quickstart [\#686](https://github.com/feelpp/feelpp/issues/686)
- Implement Ksp post and pre solve functions [\#685](https://github.com/feelpp/feelpp/issues/685)
- Preconditioner, Worldcomm, rebuild [\#682](https://github.com/feelpp/feelpp/issues/682)
- Package not compiling [\#679](https://github.com/feelpp/feelpp/issues/679)
- FTBS with clang: feelmodels/modelproperties.cpp [\#676](https://github.com/feelpp/feelpp/issues/676)
- Exporter prefix [\#672](https://github.com/feelpp/feelpp/issues/672)
- Json parser does not support comments in boost 1.59.0 [\#659](https://github.com/feelpp/feelpp/issues/659)
- Bug in assignment operator for forms [\#656](https://github.com/feelpp/feelpp/issues/656)
- Refactor createSubmesh [\#648](https://github.com/feelpp/feelpp/issues/648)
- Use of two "nested" preconditioners fails in parallel [\#645](https://github.com/feelpp/feelpp/issues/645)
- nonlinear pow function works only with integer [\#636](https://github.com/feelpp/feelpp/issues/636)
- Geometry file parse variable bug [\#634](https://github.com/feelpp/feelpp/issues/634)
- documentation: add a link to the book on feelpp.org [\#632](https://github.com/feelpp/feelpp/issues/632)
- EnsightGold exporter is broken [\#621](https://github.com/feelpp/feelpp/issues/621)
- Reinitialization with fast marching method in sequential on mesh with hypercubes \(and Simplexes\) [\#620](https://github.com/feelpp/feelpp/issues/620)
- FTBS with petsc/slepc 3.6.0 [\#617](https://github.com/feelpp/feelpp/issues/617)
- Exporters: behavior differences between add\( ... \) function of exporter and add\( ... \) function of a time step [\#604](https://github.com/feelpp/feelpp/issues/604)
- Bug in blockns [\#601](https://github.com/feelpp/feelpp/issues/601)
- add createSubVector for PetscVector [\#599](https://github.com/feelpp/feelpp/issues/599)
- Quickstart sample not building: feelpp\_qs\_sm\_3d [\#590](https://github.com/feelpp/feelpp/issues/590)
- Optimisation of laplacian for p=2 [\#581](https://github.com/feelpp/feelpp/issues/581)
- Vectorial Laplacian and Hypercube [\#580](https://github.com/feelpp/feelpp/issues/580)
- Allow new quadrature formulas in integrate [\#564](https://github.com/feelpp/feelpp/issues/564)
- EigenSolver : remove unconverged eigenfunctions [\#562](https://github.com/feelpp/feelpp/issues/562)
- Wrong exact integration value from testsuite [\#559](https://github.com/feelpp/feelpp/issues/559)
- Ensight exporter and 2d markers [\#554](https://github.com/feelpp/feelpp/issues/554)
- markerToDof using face marker [\#553](https://github.com/feelpp/feelpp/issues/553)
- VTK exporter 3D numbering [\#551](https://github.com/feelpp/feelpp/issues/551)
- Providing options to Petsc. [\#550](https://github.com/feelpp/feelpp/issues/550)
- Add support for random number generation in language [\#547](https://github.com/feelpp/feelpp/issues/547)
- L2 projection seems broken in feeldicr/projector.cpp [\#541](https://github.com/feelpp/feelpp/issues/541)
- Support Null Space in solver  [\#531](https://github.com/feelpp/feelpp/issues/531)
- Linking fails for high-order geometries with hypercube elements  [\#528](https://github.com/feelpp/feelpp/issues/528)
- Problem inside createGMSHMesh [\#526](https://github.com/feelpp/feelpp/issues/526)
- Load several config files [\#525](https://github.com/feelpp/feelpp/issues/525)
- Feel++ 0.100.0 Beta 1 release doesn't compile on OS X [\#519](https://github.com/feelpp/feelpp/issues/519)
- Gmsh header lost [\#517](https://github.com/feelpp/feelpp/issues/517)
- Problem in macro FEELPP\_VERSION\_GREATER\_THAN [\#514](https://github.com/feelpp/feelpp/issues/514)
- homebrew compilation fails [\#513](https://github.com/feelpp/feelpp/issues/513)
- Problems when linking Feel++ develop version [\#494](https://github.com/feelpp/feelpp/issues/494)
- Support variable expansion in options [\#391](https://github.com/feelpp/feelpp/issues/391)
- Mesh export for parallel execution [\#367](https://github.com/feelpp/feelpp/issues/367)
- Bug in mesh generated by operator Lagrange P1 in 3d [\#199](https://github.com/feelpp/feelpp/issues/199)
- Support laplacian keyword for scalar and vector fields [\#146](https://github.com/feelpp/feelpp/issues/146)
- Support mean linear functional [\#704](https://github.com/feelpp/feelpp/issues/704)
- Refactor CreateSubMeshTool  [\#700](https://github.com/feelpp/feelpp/issues/700)
- Change default FEELPP\_MESH\_MAX\_ORDER to 2 [\#697](https://github.com/feelpp/feelpp/issues/697)
- Exporter Ensight: variable names with space characters [\#692](https://github.com/feelpp/feelpp/issues/692)
- provide free function to generate a VectorPetsc shared/unique pointer from a PETSc vector [\#688](https://github.com/feelpp/feelpp/issues/688)
- FTBS thermodyn  [\#677](https://github.com/feelpp/feelpp/issues/677)
- Support symmetric/SPD matrices and trigger associated solver/preconditioners  [\#673](https://github.com/feelpp/feelpp/issues/673)
- Add functions to check for Inf and NaN in eigen3 data structures [\#669](https://github.com/feelpp/feelpp/issues/669)
- Support for time adaptation  [\#666](https://github.com/feelpp/feelpp/issues/666)
- Support addition bilinear form scaled by a scalar [\#664](https://github.com/feelpp/feelpp/issues/664)
- Improve timer support [\#657](https://github.com/feelpp/feelpp/issues/657)
- Reduce mesh data structure memory footprint and improve loading [\#653](https://github.com/feelpp/feelpp/issues/653)
- Allow to change value on diagonal for elimination [\#652](https://github.com/feelpp/feelpp/issues/652)
- Add support to get test and trial function in dsel from expression [\#651](https://github.com/feelpp/feelpp/issues/651)
- create meaningful type with using for mesh filters [\#647](https://github.com/feelpp/feelpp/issues/647)
- Add support for description of fields  [\#646](https://github.com/feelpp/feelpp/issues/646)
- support markededges\(\) as an alias to markedfaces\(\) in 2D [\#644](https://github.com/feelpp/feelpp/issues/644)
- Move to c++14 by default [\#640](https://github.com/feelpp/feelpp/issues/640)
- Support range\(\) to create lists containing arithmetic  progressions [\#639](https://github.com/feelpp/feelpp/issues/639)
- Support interpolant from H^1 to H^curl and more generally the De Rahm Diagram [\#638](https://github.com/feelpp/feelpp/issues/638)
- Add control for model instantiation in cmake  [\#629](https://github.com/feelpp/feelpp/issues/629)
- Refactor mesh/filters.hpp [\#626](https://github.com/feelpp/feelpp/issues/626)
- Add free functions for accessing local and global ranks in data structures [\#625](https://github.com/feelpp/feelpp/issues/625)
- Allow different C++ standard support  [\#622](https://github.com/feelpp/feelpp/issues/622)
- Fixed mpi warning in slurm generated scripts [\#614](https://github.com/feelpp/feelpp/issues/614)
- Move precAFP to benchmarks/magnetostatic [\#613](https://github.com/feelpp/feelpp/issues/613)
- Change default path for exporter [\#611](https://github.com/feelpp/feelpp/issues/611)
- Add support for ExtendedFieldFromInterface  [\#610](https://github.com/feelpp/feelpp/issues/610)
- Improve performance of assembly of complex terms in bilinear terms [\#609](https://github.com/feelpp/feelpp/issues/609)
- Support integral evaluation of a vector of scalars, vectors or matrices [\#603](https://github.com/feelpp/feelpp/issues/603)
- Support higher order meshes for levelset [\#596](https://github.com/feelpp/feelpp/issues/596)
- Extract block diagonal matrix [\#593](https://github.com/feelpp/feelpp/issues/593)
- Bug in RT0 in 3D: no convergence [\#592](https://github.com/feelpp/feelpp/issues/592)
- Timers table for Feel++ [\#591](https://github.com/feelpp/feelpp/issues/591)
- add support for prefix in loadMesh [\#588](https://github.com/feelpp/feelpp/issues/588)
- Improve documentation [\#578](https://github.com/feelpp/feelpp/issues/578)
- FTBS inner keyword when using terminal keyword [\#577](https://github.com/feelpp/feelpp/issues/577)
- Support new keyword : msi  [\#572](https://github.com/feelpp/feelpp/issues/572)
- Support more features in the ginac parser [\#568](https://github.com/feelpp/feelpp/issues/568)
- Support HDF5 format  [\#560](https://github.com/feelpp/feelpp/issues/560)
- Support traits like is\_edge, is\_face, is\_point,... [\#556](https://github.com/feelpp/feelpp/issues/556)
- Add support for modulo [\#549](https://github.com/feelpp/feelpp/issues/549)
- Add support for casting expressions from one type to another in the language [\#548](https://github.com/feelpp/feelpp/issues/548)
- Add support for floor and ceil in language [\#546](https://github.com/feelpp/feelpp/issues/546)
- Bug in handling face dof in vectorial finite elements \(e.g. Nedelec,RT\) [\#544](https://github.com/feelpp/feelpp/issues/544)
- Support interpolation and dirichlet conditions based on range of edges and points [\#537](https://github.com/feelpp/feelpp/issues/537)
- Clean up tangent and normal computation in local interpolant [\#536](https://github.com/feelpp/feelpp/issues/536)
- Support Matrix fields  [\#535](https://github.com/feelpp/feelpp/issues/535)
- Add support for component-wise dirichlet condition in vector fields [\#534](https://github.com/feelpp/feelpp/issues/534)
- eigenPair : each call erase previous eigen functions  [\#533](https://github.com/feelpp/feelpp/issues/533)
- Support pointwise operations in Vector\<\> [\#509](https://github.com/feelpp/feelpp/issues/509)
- Customize PETSc/KSP monitors [\#503](https://github.com/feelpp/feelpp/issues/503)
- printMatlab : The script should not have the same name than the variable [\#501](https://github.com/feelpp/feelpp/issues/501)
- Add support for -mat\_mumps\_icntl\_7  [\#499](https://github.com/feelpp/feelpp/issues/499)
- FTE in feelpp\_test\_integration\_relatedmesh  [\#498](https://github.com/feelpp/feelpp/issues/498)
- Support Schur complement Pressure Mass Matrix for Stokes [\#495](https://github.com/feelpp/feelpp/issues/495)
- Support assembly PˆT A P  [\#492](https://github.com/feelpp/feelpp/issues/492)
- Optimize and cleanup DofTable [\#490](https://github.com/feelpp/feelpp/issues/490)
- Reduce compilation cost in creategmshmesh [\#488](https://github.com/feelpp/feelpp/issues/488)
- Configure Aitken tool from command line options [\#483](https://github.com/feelpp/feelpp/issues/483)
- Support map of ginac expression [\#482](https://github.com/feelpp/feelpp/issues/482)
- CMake modification: FindFeel++.cmake [\#479](https://github.com/feelpp/feelpp/issues/479)
- Support updateMarkers\(\) functions for faces [\#467](https://github.com/feelpp/feelpp/issues/467)
- Port on MAC OS Yosemite [\#466](https://github.com/feelpp/feelpp/issues/466)
- OpenMP not usable [\#464](https://github.com/feelpp/feelpp/issues/464)
- Support factorisation based preconditioner for Navier-Stokes \(e.g. BTPCD and PCD\) [\#460](https://github.com/feelpp/feelpp/issues/460)
- Support Operator framework  [\#457](https://github.com/feelpp/feelpp/issues/457)
- Support concatenation of mesh elements containers [\#455](https://github.com/feelpp/feelpp/issues/455)
- Support interprocessedges mesh filter [\#454](https://github.com/feelpp/feelpp/issues/454)
- Class Mesh  [\#453](https://github.com/feelpp/feelpp/issues/453)
- Support atan2 keyword in language [\#450](https://github.com/feelpp/feelpp/issues/450)
- FTE test\_mortar  [\#449](https://github.com/feelpp/feelpp/issues/449)
- Support new interpolation framework in OperatorInterpolation and possibly other classes [\#448](https://github.com/feelpp/feelpp/issues/448)
- Support generic WorldComm in Exporter{EnsightGold,HDF5} [\#446](https://github.com/feelpp/feelpp/issues/446)
- Support worldcomm in Ginac expression [\#445](https://github.com/feelpp/feelpp/issues/445)
- Possible deadlock in loadMesh [\#444](https://github.com/feelpp/feelpp/issues/444)
- compilation error with chi expression [\#442](https://github.com/feelpp/feelpp/issues/442)
- FTE test\_on\_inside [\#441](https://github.com/feelpp/feelpp/issues/441)
- FTE in test\_interpolation\_nedelec  [\#440](https://github.com/feelpp/feelpp/issues/440)
- Support square root of sparse matrices  [\#439](https://github.com/feelpp/feelpp/issues/439)
- Add support for jacobi elliptic functions [\#438](https://github.com/feelpp/feelpp/issues/438)
- Ensight exporter: bad output in parallel [\#406](https://github.com/feelpp/feelpp/issues/406)
- Bug when computing the curl of the curl of an expression [\#397](https://github.com/feelpp/feelpp/issues/397)
- Change ginac expression management [\#395](https://github.com/feelpp/feelpp/issues/395)
- Add local/global interpolant tests [\#392](https://github.com/feelpp/feelpp/issues/392)
- Segfault when loading/saving mesh [\#371](https://github.com/feelpp/feelpp/issues/371)
- Add support for parallel I/O via MPIIO to ensight gold format [\#326](https://github.com/feelpp/feelpp/issues/326)
- Add FILE\_INDEX support in Ensight Gold format [\#305](https://github.com/feelpp/feelpp/issues/305)
- MPI\_Scatter hangs inside Feel++ environment [\#304](https://github.com/feelpp/feelpp/issues/304)

**Merged pull requests:**

- fixes \#580 and associated to \#581: laplacian on hypercube [\#695](https://github.com/feelpp/feelpp/pull/695) ([prudhomm](https://github.com/prudhomm))
- Install Feel++ main dependencies using CMake [\#689](https://github.com/feelpp/feelpp/pull/689) ([aancel](https://github.com/aancel))
- Correction of testsuite fails from \#586 [\#683](https://github.com/feelpp/feelpp/pull/683) ([LANTZT](https://github.com/LANTZT))
- Issue \#672: Exporter prefix [\#675](https://github.com/feelpp/feelpp/pull/675) ([aancel](https://github.com/aancel))
- Feature/hdf5 grp [\#667](https://github.com/feelpp/feelpp/pull/667) ([gdolle](https://github.com/gdolle))
- Feature/prec ams [\#663](https://github.com/feelpp/feelpp/pull/663) ([vhuber](https://github.com/vhuber))
- implement \#527 : mpd and interval [\#661](https://github.com/feelpp/feelpp/pull/661) ([prudhomm](https://github.com/prudhomm))
- implement the hdf5 format in save and load [\#660](https://github.com/feelpp/feelpp/pull/660) ([prudhomm](https://github.com/prudhomm))
- Feature/derahm [\#641](https://github.com/feelpp/feelpp/pull/641) ([prudhomm](https://github.com/prudhomm))
- Holo3 Image Correlation [\#627](https://github.com/feelpp/feelpp/pull/627) ([LANTZT](https://github.com/LANTZT))
- Doxygen documentation update [\#618](https://github.com/feelpp/feelpp/pull/618) ([bachir151](https://github.com/bachir151))
- Benchmark IO [\#606](https://github.com/feelpp/feelpp/pull/606) ([youldrouis](https://github.com/youldrouis))
- msi operator tests [\#589](https://github.com/feelpp/feelpp/pull/589) ([LANTZT](https://github.com/LANTZT))
- MultiScale Image keyword  [\#585](https://github.com/feelpp/feelpp/pull/585) ([LANTZT](https://github.com/LANTZT))
- Holo3 Quadrature formula [\#570](https://github.com/feelpp/feelpp/pull/570) ([LANTZT](https://github.com/LANTZT))
- Add a Gitter chat badge to README.md [\#538](https://github.com/feelpp/feelpp/pull/538) ([gitter-badger](https://github.com/gitter-badger))
- Feature/updatemarker [\#701](https://github.com/feelpp/feelpp/pull/701) ([prudhomm](https://github.com/prudhomm))
- Feature/sanitize [\#696](https://github.com/feelpp/feelpp/pull/696) ([prudhomm](https://github.com/prudhomm))
- Feature/prec adapt ns [\#684](https://github.com/feelpp/feelpp/pull/684) ([prudhomm](https://github.com/prudhomm))
- Feature/symm [\#674](https://github.com/feelpp/feelpp/pull/674) ([prudhomm](https://github.com/prudhomm))
- Feature/findfeelpp \(Issue \#479\) [\#670](https://github.com/feelpp/feelpp/pull/670) ([aancel](https://github.com/aancel))
- Feature/faster [\#654](https://github.com/feelpp/feelpp/pull/654) ([prudhomm](https://github.com/prudhomm))
- Feature/fsi [\#616](https://github.com/feelpp/feelpp/pull/616) ([prudhomm](https://github.com/prudhomm))

## [v0.100.0-beta.7](https://github.com/feelpp/feelpp/tree/v0.100.0-beta.7) (2015-02-11)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.100.0-beta.6...v0.100.0-beta.7)

## [v0.100.0-beta.6](https://github.com/feelpp/feelpp/tree/v0.100.0-beta.6) (2015-02-11)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.100.0-beta.5...v0.100.0-beta.6)

## [v0.100.0-beta.5](https://github.com/feelpp/feelpp/tree/v0.100.0-beta.5) (2015-02-10)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.100.0-beta.4...v0.100.0-beta.5)

## [v0.100.0-beta.4](https://github.com/feelpp/feelpp/tree/v0.100.0-beta.4) (2015-02-08)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.100.0-beta.3...v0.100.0-beta.4)

## [v0.100.0-beta.3](https://github.com/feelpp/feelpp/tree/v0.100.0-beta.3) (2015-02-08)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.100.0-beta.2...v0.100.0-beta.3)

## [v0.100.0-beta.2](https://github.com/feelpp/feelpp/tree/v0.100.0-beta.2) (2015-02-08)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.100.0-beta.1...v0.100.0-beta.2)

**Closed issues:**

- Get a function from a VectorPetsc [\#524](https://github.com/feelpp/feelpp/issues/524)
- Hcurl x Pch [\#523](https://github.com/feelpp/feelpp/issues/523)
- Eigen3 with installed feel++ from apt on project. [\#521](https://github.com/feelpp/feelpp/issues/521)
- Nedelec: fix level of verbosity [\#520](https://github.com/feelpp/feelpp/issues/520)
- FindPETSc.cmake is broken with PETSc \> 3.5 [\#516](https://github.com/feelpp/feelpp/issues/516)
- Feel++ for Ubuntu 14.10 [\#515](https://github.com/feelpp/feelpp/issues/515)
- HDF5 exporter: bad output after first timestep [\#508](https://github.com/feelpp/feelpp/issues/508)
- Change of nlSolver type with setType\( \) is not taken into account [\#505](https://github.com/feelpp/feelpp/issues/505)
- Optimize high order geometric mapping [\#234](https://github.com/feelpp/feelpp/issues/234)

## [v0.100.0-beta.1](https://github.com/feelpp/feelpp/tree/v0.100.0-beta.1) (2015-01-18)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.100.0-alpha.1-assembly...v0.100.0-beta.1)

**Closed issues:**

- Bug exporter paraview MPI dof table [\#506](https://github.com/feelpp/feelpp/issues/506)
- Lots of FTBS inside benchmarks/perf and doc [\#500](https://github.com/feelpp/feelpp/issues/500)
- Problem when mesh generation fails [\#486](https://github.com/feelpp/feelpp/issues/486)
- Problem when using two-part PETSc arguments [\#485](https://github.com/feelpp/feelpp/issues/485)
- Matrix Type [\#476](https://github.com/feelpp/feelpp/issues/476)
- math::ellipjc function [\#451](https://github.com/feelpp/feelpp/issues/451)
- exporter.export [\#383](https://github.com/feelpp/feelpp/issues/383)
- Implement local interpolant framework [\#369](https://github.com/feelpp/feelpp/issues/369)
- Projector warning [\#358](https://github.com/feelpp/feelpp/issues/358)
- Visualization of a response surface  [\#302](https://github.com/feelpp/feelpp/issues/302)
- Update Feel++ documentation [\#300](https://github.com/feelpp/feelpp/issues/300)
- Add quickstart navier-stokes example [\#298](https://github.com/feelpp/feelpp/issues/298)
- FTE in test\_eim  in parallel [\#263](https://github.com/feelpp/feelpp/issues/263)
- Optimize OperatorInterpolation communicator [\#232](https://github.com/feelpp/feelpp/issues/232)
- DB issue with test\_eim [\#168](https://github.com/feelpp/feelpp/issues/168)
- Fix testsuite compilation and execution [\#88](https://github.com/feelpp/feelpp/issues/88)

## [v0.100.0-alpha.1-assembly](https://github.com/feelpp/feelpp/tree/v0.100.0-alpha.1-assembly) (2014-12-22)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.99.0-final.1...v0.100.0-alpha.1-assembly)

**Closed issues:**

- Wrong interpolated values with Eigen backend  [\#491](https://github.com/feelpp/feelpp/issues/491)
- Sign of Nedelec [\#489](https://github.com/feelpp/feelpp/issues/489)
- Weird deadlock with filters [\#484](https://github.com/feelpp/feelpp/issues/484)
- Add example to store forms, mesh and function spaces in data structure [\#481](https://github.com/feelpp/feelpp/issues/481)
- mumps atlas [\#480](https://github.com/feelpp/feelpp/issues/480)
- Bug boost-1.57 matrix ublas [\#478](https://github.com/feelpp/feelpp/issues/478)
- vf::project with extend doftable [\#477](https://github.com/feelpp/feelpp/issues/477)
- In-Situ visualization [\#475](https://github.com/feelpp/feelpp/issues/475)
- VTK Exporter [\#474](https://github.com/feelpp/feelpp/issues/474)
- Restart with Ensight Gold is broken [\#473](https://github.com/feelpp/feelpp/issues/473)
- Bug in ensightgold exporter [\#472](https://github.com/feelpp/feelpp/issues/472)
- Expressions built from GinaC::ex [\#469](https://github.com/feelpp/feelpp/issues/469)
- Segmentation fault in doc/manual/laplacian/laplacian\_polar.cpp [\#463](https://github.com/feelpp/feelpp/issues/463)
- Reduce mpi communication in exporter [\#462](https://github.com/feelpp/feelpp/issues/462)
- Bad behavior of solver with Petsc 3.5.x [\#461](https://github.com/feelpp/feelpp/issues/461)
- Static geometry with exporters  [\#456](https://github.com/feelpp/feelpp/issues/456)
- Problem with CMakeCache [\#452](https://github.com/feelpp/feelpp/issues/452)
- Release 0.99.0-final.1 cmake fail [\#437](https://github.com/feelpp/feelpp/issues/437)
- Merging feature/explicit into develop [\#387](https://github.com/feelpp/feelpp/issues/387)
- Add options for exporting in one or several files \(either domain or time\) [\#353](https://github.com/feelpp/feelpp/issues/353)
- extend p0 continuous space to vectorial case in // [\#225](https://github.com/feelpp/feelpp/issues/225)
- Support HDF5/XMDF  formats [\#194](https://github.com/feelpp/feelpp/issues/194)

## [v0.99.0-final.1](https://github.com/feelpp/feelpp/tree/v0.99.0-final.1) (2014-09-07)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.99.0-beta.6...v0.99.0-final.1)

**Closed issues:**

- Support more continuous integration using Travis [\#436](https://github.com/feelpp/feelpp/issues/436)
- Enable support for simd  [\#435](https://github.com/feelpp/feelpp/issues/435)
- MPIIO integer size detection breaks feel++ 32 bits platforms [\#434](https://github.com/feelpp/feelpp/issues/434)
- FindXdmf.cmake missing [\#433](https://github.com/feelpp/feelpp/issues/433)
- Add support for set of elements of function spaces [\#430](https://github.com/feelpp/feelpp/issues/430)
- Add compatibility headers in contrib/gmsh depending on version [\#425](https://github.com/feelpp/feelpp/issues/425)
- Add application to provide various mesh information [\#417](https://github.com/feelpp/feelpp/issues/417)
- Add support for \(non-linear\) optimisation libraries [\#407](https://github.com/feelpp/feelpp/issues/407)
- Python Wrapping of a Laplacian example [\#366](https://github.com/feelpp/feelpp/issues/366)
- Benchmark ublas vs eigen3 vs nt2 [\#238](https://github.com/feelpp/feelpp/issues/238)

## [v0.99.0-beta.6](https://github.com/feelpp/feelpp/tree/v0.99.0-beta.6) (2014-08-31)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.99.0-beta.4...v0.99.0-beta.6)

## [v0.99.0-beta.4](https://github.com/feelpp/feelpp/tree/v0.99.0-beta.4) (2014-08-30)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.99.0-beta.3...v0.99.0-beta.4)

**Closed issues:**

- HDF5 file format [\#368](https://github.com/feelpp/feelpp/issues/368)

## [v0.99.0-beta.3](https://github.com/feelpp/feelpp/tree/v0.99.0-beta.3) (2014-08-29)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.99.0-beta.2...v0.99.0-beta.3)

**Closed issues:**

- Add backend as argument to form1 and form2 [\#431](https://github.com/feelpp/feelpp/issues/431)
- develop branch currently broken [\#429](https://github.com/feelpp/feelpp/issues/429)
- Update petsc to 3.5.x on mesostra [\#428](https://github.com/feelpp/feelpp/issues/428)
- Update Gmsh to 2.8.5 \(or later\) on mesostra [\#424](https://github.com/feelpp/feelpp/issues/424)

**Merged pull requests:**

- Internship file formats [\#381](https://github.com/feelpp/feelpp/pull/381) ([VANTHONG](https://github.com/VANTHONG))
- Internship Python [\#380](https://github.com/feelpp/feelpp/pull/380) ([LANTZT](https://github.com/LANTZT))

## [v0.99.0-beta.2](https://github.com/feelpp/feelpp/tree/v0.99.0-beta.2) (2014-08-26)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.99.0-beta.1...v0.99.0-beta.2)

**Closed issues:**

- Add support for Matrix transpose without assembly [\#427](https://github.com/feelpp/feelpp/issues/427)
- Add support for newMatrix\(\) without args [\#426](https://github.com/feelpp/feelpp/issues/426)
- problem in feature-gmsh-in-memory  [\#423](https://github.com/feelpp/feelpp/issues/423)

## [v0.99.0-beta.1](https://github.com/feelpp/feelpp/tree/v0.99.0-beta.1) (2014-08-20)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.98.0...v0.99.0-beta.1)

**Closed issues:**

- Add Eigen3 3.2.2 to contrib [\#422](https://github.com/feelpp/feelpp/issues/422)
- Better support ML with cmake [\#421](https://github.com/feelpp/feelpp/issues/421)
- Support boost 1.56 [\#419](https://github.com/feelpp/feelpp/issues/419)
- Add functionality to check/test Feel++ version [\#418](https://github.com/feelpp/feelpp/issues/418)
- Support PETSc 3.5.X and above [\#415](https://github.com/feelpp/feelpp/issues/415)
- Support SLEPc 3.4.X and above [\#414](https://github.com/feelpp/feelpp/issues/414)
- Set processor affinity & dump cpu information [\#413](https://github.com/feelpp/feelpp/issues/413)
- Support Reading Gmsh data structures directly in memory [\#412](https://github.com/feelpp/feelpp/issues/412)
- Port to cmake 3.0 [\#411](https://github.com/feelpp/feelpp/issues/411)
- Add an option to enable/disable creation of the np\_\<nproc\> subdirectory [\#410](https://github.com/feelpp/feelpp/issues/410)
- problem with markerToDof function  [\#409](https://github.com/feelpp/feelpp/issues/409)
- Bug in graph construction: more non zero entries in rows than there are entries [\#408](https://github.com/feelpp/feelpp/issues/408)
- Need to access to the neighbours of dof and to change value of functions only on some dof [\#404](https://github.com/feelpp/feelpp/issues/404)
- Exporter Ensight not work [\#403](https://github.com/feelpp/feelpp/issues/403)
- Problem with feelpp\_doc\_traces [\#401](https://github.com/feelpp/feelpp/issues/401)
- Fast Marching with Hypercube [\#399](https://github.com/feelpp/feelpp/issues/399)
- .geo parser [\#398](https://github.com/feelpp/feelpp/issues/398)
- Update Ensight to 10.0.3g in Atlas [\#396](https://github.com/feelpp/feelpp/issues/396)
- Non existing marked elements [\#389](https://github.com/feelpp/feelpp/issues/389)
- Unregistered options [\#385](https://github.com/feelpp/feelpp/issues/385)
- Random ensight case file generation depending on architecture [\#379](https://github.com/feelpp/feelpp/issues/379)
- Provide average, min and max mesh size [\#377](https://github.com/feelpp/feelpp/issues/377)
- Move all crb related tests to testsuite/feelcrb [\#376](https://github.com/feelpp/feelpp/issues/376)
- test\_eim and test\_eim\_grepl FTBS [\#375](https://github.com/feelpp/feelpp/issues/375)
- Move test\_bdf\* to testsuite/feelts [\#374](https://github.com/feelpp/feelpp/issues/374)
- Support simple operators + - in GiNaC::matrix [\#373](https://github.com/feelpp/feelpp/issues/373)
- FTE in test\_bdf2 : invalid c++ code generated at runtime by ginac [\#372](https://github.com/feelpp/feelpp/issues/372)
- Bug in initialisation of CRBModel in composite case [\#361](https://github.com/feelpp/feelpp/issues/361)
- Port Feel++ to archlinux [\#360](https://github.com/feelpp/feelpp/issues/360)
- Bug in one of the tests in 3D in test\_integration\_opt \(high order geom\) [\#354](https://github.com/feelpp/feelpp/issues/354)
- Improve Ginac expression support and documentation [\#331](https://github.com/feelpp/feelpp/issues/331)
- createSubmesh in // [\#322](https://github.com/feelpp/feelpp/issues/322)
- OneFeel broken  [\#307](https://github.com/feelpp/feelpp/issues/307)
- FTBS with g++ 4.9.0 [\#270](https://github.com/feelpp/feelpp/issues/270)
- Change how result files are written to the filesystem in a parallel execution context [\#183](https://github.com/feelpp/feelpp/issues/183)
- Merge all\_gathers in feelcore/worldcomm.cpp [\#181](https://github.com/feelpp/feelpp/issues/181)
- Port to Intel Compiler [\#23](https://github.com/feelpp/feelpp/issues/23)

**Merged pull requests:**

- Feature gmsh in memory [\#416](https://github.com/feelpp/feelpp/pull/416) ([prudhomm](https://github.com/prudhomm))
- Merging with branch feature/explicit [\#388](https://github.com/feelpp/feelpp/pull/388) ([prudhomm](https://github.com/prudhomm))
- Feature/ensight [\#306](https://github.com/feelpp/feelpp/pull/306) ([prudhomm](https://github.com/prudhomm))

## [v0.98.0](https://github.com/feelpp/feelpp/tree/v0.98.0) (2014-05-22)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.98.0-beta.2...v0.98.0)

**Closed issues:**

- Bug in non conforming interpolation when space are the same but the mesh is not [\#356](https://github.com/feelpp/feelpp/issues/356)
- Bug in mortar dof table points coordinates [\#355](https://github.com/feelpp/feelpp/issues/355)
- Fix publish.sh for the deployment of Doxygen documentation in www.feelpp.org [\#352](https://github.com/feelpp/feelpp/issues/352)
- Bug in composite spaces when subspaces are the same [\#349](https://github.com/feelpp/feelpp/issues/349)
- Install a MathJAX server [\#303](https://github.com/feelpp/feelpp/issues/303)
- Support Gmsh export in parallel  [\#295](https://github.com/feelpp/feelpp/issues/295)
- Bug in test\_interpolation and possibly pointwise interpolation [\#244](https://github.com/feelpp/feelpp/issues/244)

## [v0.98.0-beta.2](https://github.com/feelpp/feelpp/tree/v0.98.0-beta.2) (2014-05-06)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.98.0-beta.1...v0.98.0-beta.2)

**Closed issues:**

- Set timeout for tests and application when used in ctest [\#350](https://github.com/feelpp/feelpp/issues/350)
- Support evaluate of expression over faces [\#348](https://github.com/feelpp/feelpp/issues/348)
- Support reading partitioned mesh on one processor  [\#346](https://github.com/feelpp/feelpp/issues/346)
- Port to gcc 4.9 [\#343](https://github.com/feelpp/feelpp/issues/343)
- Petsc error with solvereigen [\#341](https://github.com/feelpp/feelpp/issues/341)
- Error with cross product [\#340](https://github.com/feelpp/feelpp/issues/340)
- Error norm for CRB models using EIM [\#339](https://github.com/feelpp/feelpp/issues/339)
- Unable to compile \(at least with gcc \>= 4.7\) [\#338](https://github.com/feelpp/feelpp/issues/338)
- Scotch5 and HomeBrew [\#337](https://github.com/feelpp/feelpp/issues/337)
- For install feel++ on Ubuntu 12.04 [\#336](https://github.com/feelpp/feelpp/issues/336)
- Petsc Error in nlsolve [\#335](https://github.com/feelpp/feelpp/issues/335)
- marker are not preserved by operatorLagrangeP1 [\#334](https://github.com/feelpp/feelpp/issues/334)
- Allow passing a specific worldComm to the Gmsh interface [\#327](https://github.com/feelpp/feelpp/issues/327)
- Random results ! [\#325](https://github.com/feelpp/feelpp/issues/325)
- Ginac and macos. [\#324](https://github.com/feelpp/feelpp/issues/324)
- CRBTrilinear should be a derived class of CRB [\#287](https://github.com/feelpp/feelpp/issues/287)
- Update clang-3.4 to the release version on Strasbourg Mesocentre [\#268](https://github.com/feelpp/feelpp/issues/268)
- Install PETSc debug version on supermuc  [\#190](https://github.com/feelpp/feelpp/issues/190)

**Merged pull requests:**

- Feature/doc [\#329](https://github.com/feelpp/feelpp/pull/329) ([prudhomm](https://github.com/prudhomm))

## [v0.98.0-beta.1](https://github.com/feelpp/feelpp/tree/v0.98.0-beta.1) (2014-03-27)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.97.4...v0.98.0-beta.1)

**Closed issues:**

- Add support for SLEPc 3.4.4 [\#321](https://github.com/feelpp/feelpp/issues/321)
- Polyvis application is currently broken [\#320](https://github.com/feelpp/feelpp/issues/320)
- EIM convergence [\#319](https://github.com/feelpp/feelpp/issues/319)

## [v0.97.4](https://github.com/feelpp/feelpp/tree/v0.97.4) (2014-03-18)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.97.3...v0.97.4)

**Closed issues:**

- Install all header from the feel++ library [\#318](https://github.com/feelpp/feelpp/issues/318)

## [v0.97.3](https://github.com/feelpp/feelpp/tree/v0.97.3) (2014-03-17)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.97.2...v0.97.3)

**Closed issues:**

- Incomplete CRB programming environment installation [\#315](https://github.com/feelpp/feelpp/issues/315)

## [v0.97.2](https://github.com/feelpp/feelpp/tree/v0.97.2) (2014-03-16)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.97.1...v0.97.2)

**Closed issues:**

- Bug in FindFeel++ as well as FindGLOG and FindGFlags [\#314](https://github.com/feelpp/feelpp/issues/314)
- Ship simple c++ feel++ examples in /usr/share/doc [\#313](https://github.com/feelpp/feelpp/issues/313)
- Add support for PETSc 3.4.4 [\#311](https://github.com/feelpp/feelpp/issues/311)

## [v0.97.1](https://github.com/feelpp/feelpp/tree/v0.97.1) (2014-03-16)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.97.0...v0.97.1)

**Closed issues:**

- Missing headers in installed version of feel++ 0.97.0 [\#312](https://github.com/feelpp/feelpp/issues/312)

## [v0.97.0](https://github.com/feelpp/feelpp/tree/v0.97.0) (2014-03-14)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.97.0-beta.1...v0.97.0)

**Closed issues:**

- Add support for isMasterRank\(\) in Environment [\#309](https://github.com/feelpp/feelpp/issues/309)
- Support Ginac expression evaluation  [\#308](https://github.com/feelpp/feelpp/issues/308)
- Add support in Ensight gold format for constant per case in files [\#296](https://github.com/feelpp/feelpp/issues/296)
- Support close graph block [\#276](https://github.com/feelpp/feelpp/issues/276)
- Support for Mortar method [\#36](https://github.com/feelpp/feelpp/issues/36)

**Merged pull requests:**

- release v0.97.0 [\#310](https://github.com/feelpp/feelpp/pull/310) ([prudhomm](https://github.com/prudhomm))

## [v0.97.0-beta.1](https://github.com/feelpp/feelpp/tree/v0.97.0-beta.1) (2014-03-09)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.97.0-alpha.3...v0.97.0-beta.1)

**Closed issues:**

- Update eigen to version 3.2.1 [\#299](https://github.com/feelpp/feelpp/issues/299)
- Segmentation fault with extended doftable [\#294](https://github.com/feelpp/feelpp/issues/294)
- Compilation issue in doftable.hpp [\#293](https://github.com/feelpp/feelpp/issues/293)
- PETSC Error during execution of doc/manual/eigen/ge\_curlcurl [\#290](https://github.com/feelpp/feelpp/issues/290)
- Support initialization of element of function spaces using an expression [\#282](https://github.com/feelpp/feelpp/issues/282)
- Assertion failure in local/global assembly using eigen fixed matrices in 3D p \>= 4 [\#271](https://github.com/feelpp/feelpp/issues/271)
- Implement Newmark algorithm in feel/feelts [\#247](https://github.com/feelpp/feelpp/issues/247)
- Merge tex/pdf manual with doxygen documentation  [\#211](https://github.com/feelpp/feelpp/issues/211)
- Memory issue for large scale reduced basis applications [\#112](https://github.com/feelpp/feelpp/issues/112)
- Implement ExodusII file format [\#108](https://github.com/feelpp/feelpp/issues/108)
- Interface with OneLaB [\#64](https://github.com/feelpp/feelpp/issues/64)
- implement the empirical interpolation method [\#26](https://github.com/feelpp/feelpp/issues/26)

**Merged pull requests:**

- Proofread  documentation [\#291](https://github.com/feelpp/feelpp/pull/291) ([dbarbier](https://github.com/dbarbier))

## [v0.97.0-alpha.3](https://github.com/feelpp/feelpp/tree/v0.97.0-alpha.3) (2014-02-26)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.97.0-alpha.2...v0.97.0-alpha.3)

**Closed issues:**

- Wrong dual error estimator behavior in parabolic case [\#281](https://github.com/feelpp/feelpp/issues/281)
- Delete feelpp\_qs\_laplacian\_onefeel [\#275](https://github.com/feelpp/feelpp/issues/275)
- Support Travis-CI  [\#274](https://github.com/feelpp/feelpp/issues/274)
- Improve eigs interface to support function spaces [\#272](https://github.com/feelpp/feelpp/issues/272)
- Bug in onefeel on MACOSX [\#266](https://github.com/feelpp/feelpp/issues/266)

## [v0.97.0-alpha.2](https://github.com/feelpp/feelpp/tree/v0.97.0-alpha.2) (2014-02-16)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.97.0-alpha.1...v0.97.0-alpha.2)

**Closed issues:**

- Simplify application help messages [\#273](https://github.com/feelpp/feelpp/issues/273)
- Refactor Ginac expression handling [\#269](https://github.com/feelpp/feelpp/issues/269)
- Support linear partitioning with one element associated to one subdomain [\#262](https://github.com/feelpp/feelpp/issues/262)

## [v0.97.0-alpha.1](https://github.com/feelpp/feelpp/tree/v0.97.0-alpha.1) (2014-02-13)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.96.0...v0.97.0-alpha.1)

**Closed issues:**

- Improve support for string Dirichlet condition handling [\#260](https://github.com/feelpp/feelpp/issues/260)
- Solver convergence for an aerothermal application [\#259](https://github.com/feelpp/feelpp/issues/259)
- Support paraview using ensightgold sos format [\#258](https://github.com/feelpp/feelpp/issues/258)
- Assertion failure when using ensightgold format [\#257](https://github.com/feelpp/feelpp/issues/257)
- FTBS in test\_eim\_grepl [\#256](https://github.com/feelpp/feelpp/issues/256)
- FTBS in test\_rbspace [\#253](https://github.com/feelpp/feelpp/issues/253)
- make does not regenerate compilation when a file is touched. [\#250](https://github.com/feelpp/feelpp/issues/250)
- FTBS in test\_eim and test\_eim\_grepl [\#249](https://github.com/feelpp/feelpp/issues/249)
- Bug in Discontinuous Galerkin in case of Mesh with hypercubes [\#248](https://github.com/feelpp/feelpp/issues/248)
- internalelements [\#245](https://github.com/feelpp/feelpp/issues/245)
- Support ghost cell in ensight gold format [\#243](https://github.com/feelpp/feelpp/issues/243)
- newMatrix with extended pattern crashes in parallel [\#242](https://github.com/feelpp/feelpp/issues/242)
- Update Feel++ 0.96.0 documentation [\#241](https://github.com/feelpp/feelpp/issues/241)
- Refactor BDFBase  [\#237](https://github.com/feelpp/feelpp/issues/237)
- Support extended stencil over a range of elements [\#227](https://github.com/feelpp/feelpp/issues/227)
- Change strategy for Feel++ headers [\#226](https://github.com/feelpp/feelpp/issues/226)
- Define an integer type for mpi rank processes [\#224](https://github.com/feelpp/feelpp/issues/224)
- Implement norm2 in the language [\#223](https://github.com/feelpp/feelpp/issues/223)
- Implement projector on the tangent plane [\#222](https://github.com/feelpp/feelpp/issues/222)
- Create configure script to generate configuration for cmake [\#219](https://github.com/feelpp/feelpp/issues/219)
- Implement a simple make check after compiling the library [\#218](https://github.com/feelpp/feelpp/issues/218)
- Substitute variables in config [\#217](https://github.com/feelpp/feelpp/issues/217)
- Add on\(\) keyword for an element\_type to set the degrees of freedom on an element range [\#213](https://github.com/feelpp/feelpp/issues/213)
- OperatorInterpolation yields wrong results on hypercube elements [\#212](https://github.com/feelpp/feelpp/issues/212)
- Update Feel++ documentation regarding MacOSX installation [\#210](https://github.com/feelpp/feelpp/issues/210)
- Spurious values in exporter [\#203](https://github.com/feelpp/feelpp/issues/203)
- benchmark - stokes\_Pressure [\#200](https://github.com/feelpp/feelpp/issues/200)
- FEELPP\_ENABLE\_MPI\_MODE=OFF obsolete ? Cleanup needed [\#198](https://github.com/feelpp/feelpp/issues/198)
- Ginac problem on hpc-login  [\#193](https://github.com/feelpp/feelpp/issues/193)
- Update Feel++ Portfile on macport [\#187](https://github.com/feelpp/feelpp/issues/187)
- Compile Feel++ on MacOsX using Xcode 5 and libc++ [\#186](https://github.com/feelpp/feelpp/issues/186)
- Interpolation issue with form1 [\#180](https://github.com/feelpp/feelpp/issues/180)
- Compilation of laplacian doesn't work with gcc 4.6/boost 1.54 [\#179](https://github.com/feelpp/feelpp/issues/179)
- benchmarks/stokes fail to compile [\#178](https://github.com/feelpp/feelpp/issues/178)
- about geofiles and data [\#172](https://github.com/feelpp/feelpp/issues/172)
- Define interprocess entities \(not only for faces\) [\#161](https://github.com/feelpp/feelpp/issues/161)
- Simplify  and extend DofTable  [\#160](https://github.com/feelpp/feelpp/issues/160)
- About the Application class - constructor\(argc,argv,ad,od\) [\#134](https://github.com/feelpp/feelpp/issues/134)
- Segfault when integrating over internalfaces  [\#124](https://github.com/feelpp/feelpp/issues/124)
- Rounding errors in bdf metadata files [\#30](https://github.com/feelpp/feelpp/issues/30)
- interpolation through matrix different  \_test/\_trial space does not work [\#4](https://github.com/feelpp/feelpp/issues/4)
- OpInterlation too slow [\#3](https://github.com/feelpp/feelpp/issues/3)

**Merged pull requests:**

- Feature/header [\#240](https://github.com/feelpp/feelpp/pull/240) ([prudhomm](https://github.com/prudhomm))

## [v0.96.0](https://github.com/feelpp/feelpp/tree/v0.96.0) (2014-01-03)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.96.0-beta.3...v0.96.0)

**Closed issues:**

- Set minimal version for Boost in cmake [\#220](https://github.com/feelpp/feelpp/issues/220)
- functions. [\#184](https://github.com/feelpp/feelpp/issues/184)
- Cleanup $HOME/feel before launching nightly tests or set another 'feel' repository [\#169](https://github.com/feelpp/feelpp/issues/169)

**Merged pull requests:**

- Feature/harts [\#216](https://github.com/feelpp/feelpp/pull/216) ([prudhomm](https://github.com/prudhomm))
- Merge feature/mortar into develop [\#207](https://github.com/feelpp/feelpp/pull/207) ([prudhomm](https://github.com/prudhomm))

## [v0.96.0-beta.3](https://github.com/feelpp/feelpp/tree/v0.96.0-beta.3) (2013-11-15)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.96.0-beta.2...v0.96.0-beta.3)

## [v0.96.0-beta.2](https://github.com/feelpp/feelpp/tree/v0.96.0-beta.2) (2013-11-14)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.96.0-beta.1...v0.96.0-beta.2)

**Closed issues:**

- Homebrew breaks Ginac expression compilation [\#209](https://github.com/feelpp/feelpp/issues/209)
- Always FEM context is used by id\_\(\) function of ReducedBasisSpace   [\#208](https://github.com/feelpp/feelpp/issues/208)
- Compiling Feel++ in Linux [\#206](https://github.com/feelpp/feelpp/issues/206)
- bug in documentation [\#196](https://github.com/feelpp/feelpp/issues/196)

## [v0.96.0-beta.1](https://github.com/feelpp/feelpp/tree/v0.96.0-beta.1) (2013-11-11)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.95.0...v0.96.0-beta.1)

**Closed issues:**

- Issue with doxygen pages in git  [\#205](https://github.com/feelpp/feelpp/issues/205)
- Intermittent crash when creating OperatorInterpolation [\#202](https://github.com/feelpp/feelpp/issues/202)
- Crash when creating a sequential functionspace  using a parallel mesh [\#201](https://github.com/feelpp/feelpp/issues/201)
- Use Slepc on Supermuc [\#197](https://github.com/feelpp/feelpp/issues/197)
- Crash in DofTable [\#195](https://github.com/feelpp/feelpp/issues/195)
- Atlas  installation [\#192](https://github.com/feelpp/feelpp/issues/192)
- Install PETSc debug version on mesostra [\#191](https://github.com/feelpp/feelpp/issues/191)
- Publish online documentation for v0.95.0 [\#189](https://github.com/feelpp/feelpp/issues/189)
- periodic boundary conditions seems buggy [\#188](https://github.com/feelpp/feelpp/issues/188)
- Support releases of Ginac excompiler and associated framework [\#185](https://github.com/feelpp/feelpp/issues/185)
- about --help [\#182](https://github.com/feelpp/feelpp/issues/182)
- Laplacian\_polar example doesn't compile due to Eigen 3.2 [\#176](https://github.com/feelpp/feelpp/issues/176)
- reserved identifier violation [\#174](https://github.com/feelpp/feelpp/issues/174)
- Include all headers only once? [\#173](https://github.com/feelpp/feelpp/issues/173)
- lowering  memory footprint  [\#97](https://github.com/feelpp/feelpp/issues/97)
- Add MatrixShell support to PETSc solver classes [\#52](https://github.com/feelpp/feelpp/issues/52)

**Merged pull requests:**

- Merge Feature/port macosx xc5 [\#204](https://github.com/feelpp/feelpp/pull/204) ([prudhomm](https://github.com/prudhomm))

## [v0.95.0](https://github.com/feelpp/feelpp/tree/v0.95.0) (2013-10-04)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.95.0-beta.3...v0.95.0)

## [v0.95.0-beta.3](https://github.com/feelpp/feelpp/tree/v0.95.0-beta.3) (2013-10-01)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.95.0-beta.2...v0.95.0-beta.3)

## [v0.95.0-beta.2](https://github.com/feelpp/feelpp/tree/v0.95.0-beta.2) (2013-09-29)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.95.0-beta.1...v0.95.0-beta.2)

## [v0.95.0-beta.1](https://github.com/feelpp/feelpp/tree/v0.95.0-beta.1) (2013-09-28)
[Full Changelog](https://github.com/feelpp/feelpp/compare/v0.94.0...v0.95.0-beta.1)

**Closed issues:**

- Memory management after matrix destructor [\#177](https://github.com/feelpp/feelpp/issues/177)
- Feel++ FTBS in crb.cpp [\#170](https://github.com/feelpp/feelpp/issues/170)
- Breakage/Conflicts between geo-variables-list option and Gmsh class interface [\#167](https://github.com/feelpp/feelpp/issues/167)
- Wrong MshFileVersion in generated geo files [\#166](https://github.com/feelpp/feelpp/issues/166)
- testsuite/feeldisc/test\_integration\_ginac fails in sequential \(apply likely to all testsuite\)  [\#165](https://github.com/feelpp/feelpp/issues/165)
- Problem with use of GiNaC on Supermuc [\#164](https://github.com/feelpp/feelpp/issues/164)
- doc/manual/adapt/Lshape FTBS [\#163](https://github.com/feelpp/feelpp/issues/163)
- Update/Add  hpc-login software : gcc 4.7.3, gcc 4.8.1, clang 3.3, petsc/slepc, ... [\#162](https://github.com/feelpp/feelpp/issues/162)
- Update to PETSc 3.4.2 and SLEPC 3.4.1 on supermuc [\#159](https://github.com/feelpp/feelpp/issues/159)
- Do not ship eigen, cln, glog and gflags when releasing Feel++ [\#157](https://github.com/feelpp/feelpp/issues/157)
- Port to Eigen 3.2 [\#156](https://github.com/feelpp/feelpp/issues/156)
- Feel++ fail to compile - petsc-3.4.2/slepc-3.4.1 [\#154](https://github.com/feelpp/feelpp/issues/154)
- Issues with faces data structure in sequential and parallel [\#147](https://github.com/feelpp/feelpp/issues/147)
- port to boost 1.53 and 1.54 [\#142](https://github.com/feelpp/feelpp/issues/142)
- memory leak in d-i7-2 [\#133](https://github.com/feelpp/feelpp/issues/133)
- problem with p0 continuous space in product spaces in parallel [\#132](https://github.com/feelpp/feelpp/issues/132)
- laplacian\_full not working in parallel [\#127](https://github.com/feelpp/feelpp/issues/127)
- port of openturns on froggy [\#115](https://github.com/feelpp/feelpp/issues/115)
- Clear temporary Ginac so when feelpp app exit [\#102](https://github.com/feelpp/feelpp/issues/102)
- use comp\(X\) in parallel [\#58](https://github.com/feelpp/feelpp/issues/58)
- specify python version on cdash [\#24](https://github.com/feelpp/feelpp/issues/24)
- trace or createSubmesh in parallel [\#13](https://github.com/feelpp/feelpp/issues/13)
- memory leak in backend-\>solve\(\)  [\#7](https://github.com/feelpp/feelpp/issues/7)

## [v0.94.0](https://github.com/feelpp/feelpp/tree/v0.94.0) (2013-08-16)
[Full Changelog](https://github.com/feelpp/feelpp/compare/feelpp-0.93.0...v0.94.0)

**Closed issues:**

- Allow rebuild partition when creating gmsh meshes [\#151](https://github.com/feelpp/feelpp/issues/151)
- add petsc and version in ctest build name [\#150](https://github.com/feelpp/feelpp/issues/150)
- port to PETSc 3.4 [\#149](https://github.com/feelpp/feelpp/issues/149)
- config file [\#148](https://github.com/feelpp/feelpp/issues/148)
- loadMesh generates an hypercube as default mesh  [\#145](https://github.com/feelpp/feelpp/issues/145)
- Testsuite  [\#143](https://github.com/feelpp/feelpp/issues/143)
- Mesh files refined twice the number of refinement levels at generation step [\#140](https://github.com/feelpp/feelpp/issues/140)
- test\_eim check fails [\#139](https://github.com/feelpp/feelpp/issues/139)
- test\_ginac fails and timeouts [\#138](https://github.com/feelpp/feelpp/issues/138)
- create submesh crashes in parallel [\#137](https://github.com/feelpp/feelpp/issues/137)
- Feel++/CDash broken ? [\#136](https://github.com/feelpp/feelpp/issues/136)
- CreateSubMesh [\#135](https://github.com/feelpp/feelpp/issues/135)
- Option --export doesn't work [\#131](https://github.com/feelpp/feelpp/issues/131)
- broken crb\_add\_model macro when optionnal SRCS [\#130](https://github.com/feelpp/feelpp/issues/130)
- BDF not working in order 4 [\#128](https://github.com/feelpp/feelpp/issues/128)
- don't store all mesh points [\#126](https://github.com/feelpp/feelpp/issues/126)
- Sequential programs appear to run by default in parallel [\#125](https://github.com/feelpp/feelpp/issues/125)
- Automatic generation of API documentation from research/ [\#122](https://github.com/feelpp/feelpp/issues/122)
- exporter ensightgold with vectorial field [\#119](https://github.com/feelpp/feelpp/issues/119)
- problem using -idv\(...\) in expression and operator linear free [\#118](https://github.com/feelpp/feelpp/issues/118)
- Edit CMakeLists.txt for doxygen [\#117](https://github.com/feelpp/feelpp/issues/117)
- Support Ensight Gold format [\#116](https://github.com/feelpp/feelpp/issues/116)
- Correspondence of gmsh and feel++ node numbering [\#101](https://github.com/feelpp/feelpp/issues/101)
- Add "t" as a symbol for time in Ginac\_Ex [\#100](https://github.com/feelpp/feelpp/issues/100)
- problem with gradient of fonction real dim= Dim and topological dim=Dim-1 [\#33](https://github.com/feelpp/feelpp/issues/33)
- Segfault in the language with g++ 4.7 [\#25](https://github.com/feelpp/feelpp/issues/25)

## [feelpp-0.93.0](https://github.com/feelpp/feelpp/tree/feelpp-0.93.0) (2013-05-26)
[Full Changelog](https://github.com/feelpp/feelpp/compare/version-0.92.1...feelpp-0.93.0)

**Closed issues:**

- test\_ginac fails to compile [\#123](https://github.com/feelpp/feelpp/issues/123)
- code in doc/manual/heatns fail to compile [\#121](https://github.com/feelpp/feelpp/issues/121)
- Codes in doc/manual/dd fail to compile [\#120](https://github.com/feelpp/feelpp/issues/120)
- Compilation error of CRB models in develop branch [\#111](https://github.com/feelpp/feelpp/issues/111)
- compilation failed with clang3.1 in develop branch [\#110](https://github.com/feelpp/feelpp/issues/110)
- Load Gmsh supported file format seamlessly [\#109](https://github.com/feelpp/feelpp/issues/109)
- cmake fails when one vm with only one core [\#107](https://github.com/feelpp/feelpp/issues/107)
- Improve website documentation [\#106](https://github.com/feelpp/feelpp/issues/106)
- error using unitSquare\(\) in branch rbframework with gcc46 [\#104](https://github.com/feelpp/feelpp/issues/104)
- Off by one error in mesh point indices [\#103](https://github.com/feelpp/feelpp/issues/103)
- \(Re\)Moving libmatheval  [\#99](https://github.com/feelpp/feelpp/issues/99)
- feel++0.92.0 on oneiric, make check fails to build  mortar app [\#98](https://github.com/feelpp/feelpp/issues/98)
- Port Feel++ on SUPERMUC [\#95](https://github.com/feelpp/feelpp/issues/95)
- improve export when same mesh reused [\#79](https://github.com/feelpp/feelpp/issues/79)
- crb applications in research/apee fail to compile in Debug mode on Debian/Ubuntu [\#69](https://github.com/feelpp/feelpp/issues/69)
- problem with dot function in parallel when using vectors [\#45](https://github.com/feelpp/feelpp/issues/45)
- support for gmsh binary format [\#38](https://github.com/feelpp/feelpp/issues/38)
- Reorder dof with respect to interior, face, edge and vertex dof of the domain [\#15](https://github.com/feelpp/feelpp/issues/15)

## [version-0.92.1](https://github.com/feelpp/feelpp/tree/version-0.92.1) (2013-03-10)
[Full Changelog](https://github.com/feelpp/feelpp/compare/version-0.92...version-0.92.1)

**Closed issues:**

- Why is there a VectorPetscMPI ? or equivalently what should it do differently from VectorPetsc [\#96](https://github.com/feelpp/feelpp/issues/96)
- GFlags not used [\#91](https://github.com/feelpp/feelpp/issues/91)
- Is there any instruction to install the feel++ on Windows 7+VS2010+Intel Fortran 2011? [\#57](https://github.com/feelpp/feelpp/issues/57)
- use multVector directly with element\_type [\#56](https://github.com/feelpp/feelpp/issues/56)

## [version-0.92](https://github.com/feelpp/feelpp/tree/version-0.92) (2013-03-03)
**Closed issues:**

- HeatSink not working in parallel [\#94](https://github.com/feelpp/feelpp/issues/94)
- HeatSink not working in parallel [\#93](https://github.com/feelpp/feelpp/issues/93)
- No feel++ applications running [\#90](https://github.com/feelpp/feelpp/issues/90)
- Allow saving results using relative path  [\#89](https://github.com/feelpp/feelpp/issues/89)
- cmake \(feelpp\) & boost [\#87](https://github.com/feelpp/feelpp/issues/87)
- cmake version on ubuntu [\#86](https://github.com/feelpp/feelpp/issues/86)
- doc/manual/adapt crash on develop branch [\#85](https://github.com/feelpp/feelpp/issues/85)
- assertion for the inner keword [\#84](https://github.com/feelpp/feelpp/issues/84)
- Rename libfeel++ to libfeelpp for consistency [\#83](https://github.com/feelpp/feelpp/issues/83)
- cleanup tutorial examples  [\#82](https://github.com/feelpp/feelpp/issues/82)
- rename libfeel++ into libfeelpp [\#81](https://github.com/feelpp/feelpp/issues/81)
- cleanup \(remove?\) gmm installation [\#80](https://github.com/feelpp/feelpp/issues/80)
- option function interface and handling exception [\#78](https://github.com/feelpp/feelpp/issues/78)
- fsi crash [\#77](https://github.com/feelpp/feelpp/issues/77)
- Compilation error of CRB \(with EIM\) application in develop branch [\#76](https://github.com/feelpp/feelpp/issues/76)
- Feel++ FTBS in debug mode [\#75](https://github.com/feelpp/feelpp/issues/75)
- Update Feel++ on Curie  [\#74](https://github.com/feelpp/feelpp/issues/74)
- Update Glog to 3.3 [\#73](https://github.com/feelpp/feelpp/issues/73)
- Update to Eigen 3.1.2 [\#72](https://github.com/feelpp/feelpp/issues/72)
- Feel++ Installation process incomplete [\#71](https://github.com/feelpp/feelpp/issues/71)
- Update Feel++ Documentation/Tutorial [\#70](https://github.com/feelpp/feelpp/issues/70)
- Fast localisation of mesh elements between meshes related by extraction [\#68](https://github.com/feelpp/feelpp/issues/68)
- Port Feel++ on Suse [\#67](https://github.com/feelpp/feelpp/issues/67)
- Port Feel++ on Scientific Linux [\#66](https://github.com/feelpp/feelpp/issues/66)
- Automatic generation of User and Reference Manual [\#61](https://github.com/feelpp/feelpp/issues/61)
- 10 min crash course for Feel++ [\#60](https://github.com/feelpp/feelpp/issues/60)
- Invalid communicator [\#59](https://github.com/feelpp/feelpp/issues/59)
- feelpp\_doc\_LShape segfaults [\#55](https://github.com/feelpp/feelpp/issues/55)
- Ginac is not building properly causing FTBS [\#54](https://github.com/feelpp/feelpp/issues/54)
- warnings regarding the mesh [\#53](https://github.com/feelpp/feelpp/issues/53)
- added computation of the mean of a function [\#51](https://github.com/feelpp/feelpp/issues/51)
- support for a mix periodic/non periodic conditions in product spaces [\#50](https://github.com/feelpp/feelpp/issues/50)
- periodic vectorial functionspace fail [\#49](https://github.com/feelpp/feelpp/issues/49)
- keep information when create a submesh [\#48](https://github.com/feelpp/feelpp/issues/48)
- failed to compile on ubuntu 12.04 gcc 4.6 [\#47](https://github.com/feelpp/feelpp/issues/47)
- gmsh - createGMSHMesh \( writting the .geo \) - problem with number of partition [\#46](https://github.com/feelpp/feelpp/issues/46)
- Wrong number of dof in parallel ? [\#44](https://github.com/feelpp/feelpp/issues/44)
- geomap strategy bug with ho [\#43](https://github.com/feelpp/feelpp/issues/43)
- Support both Gmsh from library and executable [\#42](https://github.com/feelpp/feelpp/issues/42)
- Mesh refinement support from Gmsh library [\#39](https://github.com/feelpp/feelpp/issues/39)
- periodic boundary conditions do not compile for composite spaces [\#37](https://github.com/feelpp/feelpp/issues/37)
- Add Eigen3 backend [\#35](https://github.com/feelpp/feelpp/issues/35)
- port on curie \(TGCC/Genci/Prace\) [\#34](https://github.com/feelpp/feelpp/issues/34)
- Seamless parallelism [\#32](https://github.com/feelpp/feelpp/issues/32)
- marker on periodic elements [\#31](https://github.com/feelpp/feelpp/issues/31)
- Improve logging capabilities \(e.g. use glog\) [\#29](https://github.com/feelpp/feelpp/issues/29)
- Implement L\_infinity norm  [\#28](https://github.com/feelpp/feelpp/issues/28)
- Export \(gmsh/ensight\) functions of product spaces [\#27](https://github.com/feelpp/feelpp/issues/27)
- Port to clang 3.1 [\#22](https://github.com/feelpp/feelpp/issues/22)
- add support for += on elements of function space [\#21](https://github.com/feelpp/feelpp/issues/21)
- failed to compile on ubuntu 12.04 gcc 4.6 with mpich2 [\#20](https://github.com/feelpp/feelpp/issues/20)
- Implement new keywords det\(\) and inv\(\) in the variational formulation language [\#19](https://github.com/feelpp/feelpp/issues/19)
- fail to change hsize in geofile [\#18](https://github.com/feelpp/feelpp/issues/18)
- Serialize the mesh data structure  [\#17](https://github.com/feelpp/feelpp/issues/17)
- Enhance product of function spaces [\#16](https://github.com/feelpp/feelpp/issues/16)
- discrepancy betwen manual and code for laplacian.cpp [\#12](https://github.com/feelpp/feelpp/issues/12)
- Simplify Feel++ application setup \(geo files, cfg files,...\) [\#11](https://github.com/feelpp/feelpp/issues/11)
- MPI errors with nlSolve function [\#10](https://github.com/feelpp/feelpp/issues/10)
- compilation issue with geo\(\) interface [\#9](https://github.com/feelpp/feelpp/issues/9)
- memory leak in backend-\>solve\(\)  [\#8](https://github.com/feelpp/feelpp/issues/8)
- Lagrange P1 [\#6](https://github.com/feelpp/feelpp/issues/6)
- integration of mesh adaptation in Feel++ [\#5](https://github.com/feelpp/feelpp/issues/5)
- disable benchmarks compilation by default [\#2](https://github.com/feelpp/feelpp/issues/2)
- increase template-depth to 256 [\#1](https://github.com/feelpp/feelpp/issues/1)



\* *This Change Log was automatically generated by [github_changelog_generator](https://github.com/skywinder/Github-Changelog-Generator)*