/* -*- mode: c++; coding: utf-8; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4; show-trailing-whitespace: t  -*-
 
 This file is part of the Feel++ library
 
 Author(s): Christophe Prud'homme <christophe.prudhomme@feelpp.org>
 Date: 16 Feb 2015
 
 Copyright (C) 2015 Feel++ Consortium
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef FEELPP_PTR_HPP
#define FEELPP_PTR_HPP 1

#include <memory>
#include <boost/shared_ptr.hpp>
#include <boost/detail/is_xxx.hpp>

namespace Feel
{
namespace detail
{
BOOST_DETAIL_IS_XXX_DEF( shared_ptr, boost::shared_ptr, 1 )
}
}

namespace std
{
// make_unique is defined for c++14 and beyond
#if __cplusplus <= 201200L
/**
 * provide the c++14 implementation of std::make_unique
 */
template<typename T, typename... Ts>
std::unique_ptr<T>
make_unique(Ts&&... params)
{
    return std::unique_ptr<T>(new T(std::forward<Ts>(params)...));
}
#endif

}
#endif
